read("costs.gp")

data_to_string(data) = {
  s = "";
  start = 1;
  while(start < matsize(data)[1] && data[start,1] == 0, start += 1);
  prevn = data[start,1];
  for(i=start, matsize(data)[1],
    if(data[i,1] != prevn, s = concat(s,"\n"));
    prevn = data[i,1];
    for(j=1,#data[i,]-1,s = concat([s, round(data[i,j]), ", "]));
    s = concat([s, round(data[i,#data[i,]]), "\n"]));
  s;
}

write_data(fn, data) = {
  write(concat([output_dir,fn,".dat"]), data_to_string(data));
}

do() = {
  ps = [434];
  maxmaxmemory = 1000;

  tani_maxmemory_data = [];
  for(i=1,#ps,p=ps[i];
    for(mm=isogeny_cost(p)[3], maxmaxmemory,
      res = data_tani_with_maxmemory(p,isogeny_cost(p),mm);
      tani_maxmemory_data = matconcat([tani_maxmemory_data; res])));
  write_data("tani", tani_maxmemory_data);

  grover_data = [];
  for(i=1,#ps,p=ps[i];
    for(mm=isogeny_cost(p)[3], maxmaxmemory,
      grover_data = matconcat([grover_data; data_grover_with_maxmemory(p,isogeny_cost(p),mm)])));
  write_data("grover", grover_data);

  vw_data = [];
  for(i=1,#ps,p=ps[i];
    for(mm=isogeny_cost(p)[3], maxmaxmemory,
      vw_data = matconcat([vw_data; data_vw_with_maxmemory(p,isogeny_cost(p),mm)])));
  write_data("vw", vw_data);
}

do();
quit();
