read("costs.gp")

data_to_string(data) = {
  s = "";
  start = 1;
  while(start < matsize(data)[1] && data[start,1] == 0, start += 1);
  prevn = data[start,1];
  for(i=start, matsize(data)[1],
  	s = concat([s,"("]);
    for(j=1,#data[i,]-1,s = concat([s, data[i,j], ", "]));
    s = concat([s, data[i,#data[i,]], ") "]));
  s;
}

write_data(fn, data) = {
  write(concat([output_dir,fn,".dat"]), data_to_string(data));
}


do() = {
  p=434;
  tani_gate_data=[];
  grover_gate_data=[];
  vw_gate_data=[];
  tani_depth_data=[];
  grover_depth_data=[];
  vw_depth_data=[];
  costs=isogeny_cost(p);
  minmaxdepth=costs[2];
  maxmaxdepth=costs[2]+p*3.0/8.0;
  for (md=minmaxdepth,maxmaxdepth,
  	tani_res=data_tani_with_maxdepth(p,costs,md);
  	tani_gate_data=matconcat([tani_gate_data; [tani_res[4],tani_res[2]]]);
  	tani_depth_data=matconcat([tani_depth_data; [tani_res[4],tani_res[3]]]);
  	grover_res=data_grover_with_maxdepth(p,costs,md);
  	grover_gate_data=matconcat([grover_gate_data; [grover_res[4],grover_res[2]]]);
  	grover_depth_data=matconcat([grover_depth_data; [grover_res[4],grover_res[3]]]);
  	vw_res=data_vw_with_maxdepth(p,costs,md);
  	vw_gate_data=matconcat([vw_gate_data; [vw_res[4],vw_res[2]]]);
  	vw_depth_data=matconcat([vw_depth_data; [vw_res[4],vw_res[3]]]);
  );
  write_data("tani_gate_plot",tani_gate_data);
  write_data("grover_gate_plot",grover_gate_data);
  write_data("vw_gate_plot",vw_gate_data);
  write_data("tani_depth_plot",tani_depth_data);
  write_data("grover_depth_plot",grover_depth_data);
  write_data("vw_depth_plot",vw_depth_data)
}

do();
quit();
